<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>fwCtrlUtils: CtrlOOUtils library reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">fwCtrlUtils
   &#160;<span id="projectnumber">8.5.2</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="modules.html"><span>Modules</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('group__CtrlOOUtils.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">CtrlOOUtils library reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader">RTTI Functions</h2></td></tr>
<tr><td class="ititle" colspan="2"><p><a class="anchor" id="amgrpa26d81320d117b23554562a5d349dee6"></a> The following functions are related to the RunTime Type Information functionality. </p>
</td></tr>
<tr class="memitem:gad62183931e951ae45afbca95d8683153"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__CtrlOOUtils.html#gad62183931e951ae45afbca95d8683153">fwClassExists</a> (string className)</td></tr>
<tr class="separator:gad62183931e951ae45afbca95d8683153"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaeb37d71db0ded24e58e2c45a1818be56"><td class="memItemLeft" align="right" valign="top">dyn_string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__CtrlOOUtils.html#gaeb37d71db0ded24e58e2c45a1818be56">fwClassNames</a> ()</td></tr>
<tr class="separator:gaeb37d71db0ded24e58e2c45a1818be56"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gae63ccc45ff8b44cd2782c1dbd049c6fa"><td class="memItemLeft" align="right" valign="top">shared_ptr&lt; className &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__CtrlOOUtils.html#gae63ccc45ff8b44cd2782c1dbd049c6fa">fwCreateInstance</a> (string className)</td></tr>
<tr class="separator:gae63ccc45ff8b44cd2782c1dbd049c6fa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gab8fb94d265ae60ff799d1400c30e515d"><td class="memItemLeft" align="right" valign="top">dyn_string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__CtrlOOUtils.html#gab8fb94d265ae60ff799d1400c30e515d">fwClassMemberVars</a> (string className)</td></tr>
<tr class="separator:gab8fb94d265ae60ff799d1400c30e515d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaab6a30d4d6ee78b09b03d8e19bbac2e7"><td class="memItemLeft" align="right" valign="top">dyn_string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__CtrlOOUtils.html#gaab6a30d4d6ee78b09b03d8e19bbac2e7">fwClassMemberFuncs</a> (string className)</td></tr>
<tr class="separator:gaab6a30d4d6ee78b09b03d8e19bbac2e7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga112498c037a24d2560b5f2323be8f74d"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__CtrlOOUtils.html#ga112498c037a24d2560b5f2323be8f74d">fwGetBaseClass</a> (string className)</td></tr>
<tr class="separator:ga112498c037a24d2560b5f2323be8f74d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga8b712c1097489b183594acb71eabcbe6"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__CtrlOOUtils.html#ga8b712c1097489b183594acb71eabcbe6">fwIsInstanceOf</a> (const anytype &amp;obj|const shared_ptr&lt;&gt; obj, string className)</td></tr>
<tr class="separator:ga8b712c1097489b183594acb71eabcbe6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gadeb664365b7154026af82f6dcba38ecb"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__CtrlOOUtils.html#gadeb664365b7154026af82f6dcba38ecb">fwGetClass</a> (const anytype &amp;obj|const shared_ptr&lt;&gt; obj|vector&lt;&gt; obj)</td></tr>
<tr class="separator:gadeb664365b7154026af82f6dcba38ecb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gac80aceb06a55dbb12f70dc42a675d80b"><td class="memItemLeft" align="right" valign="top">function_ptr&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__CtrlOOUtils.html#gac80aceb06a55dbb12f70dc42a675d80b">fwGetFuncPtr</a> (string funcName)</td></tr>
<tr class="separator:gac80aceb06a55dbb12f70dc42a675d80b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga739d2d178d1779dee2ac1534e5d906c9"><td class="memItemLeft" align="right" valign="top">anytype&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__CtrlOOUtils.html#ga739d2d178d1779dee2ac1534e5d906c9">fwInvokeMethod</a> (anytype &amp;obj|shared_ptr&lt;&gt; obj, string method,...)</td></tr>
<tr class="separator:ga739d2d178d1779dee2ac1534e5d906c9"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader">Exceptions and Stack Trace</h2></td></tr>
<tr><td class="ititle" colspan="2"><p><a class="anchor" id="amgrp2cff3eecda51977f71fd2a6c07b21220"></a>The following functions are related to effective handling of exceptions and stack traces. </p>
</td></tr>
<tr class="memitem:ga1cfe49316c787c256b0fd32b310f7225"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__CtrlOOUtils.html#ga1cfe49316c787c256b0fd32b310f7225">fwRethrow</a> ()</td></tr>
<tr class="separator:ga1cfe49316c787c256b0fd32b310f7225"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gafaecd441269ebe1c4883b2b53cce980e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__CtrlOOUtils.html#gafaecd441269ebe1c4883b2b53cce980e">fwThrowWithStackTrace</a> (errClass|dyn_errClass exception, dyn_string stackTrace|int cutFrames)</td></tr>
<tr class="separator:gafaecd441269ebe1c4883b2b53cce980e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga2398c9f637e4ea11cf138e728ececdbf"><td class="memItemLeft" align="right" valign="top">anytype&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__CtrlOOUtils.html#ga2398c9f637e4ea11cf138e728ececdbf">fwGetMember</a> (const anytype &amp;obj|shared_ptr&lt;&gt; obj, string memberName)</td></tr>
<tr class="separator:ga2398c9f637e4ea11cf138e728ececdbf"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>CtrlOOUtils module extends the tools related to Object-Oriented programming in CTRL++.</p>
<p>Please refer to the <a class="el" href="CtrlOOUtilsManual.html">CtrlOOUtils Programmer Manual</a> section for a comprehensive programmer's guide. </p>
<h2 class="groupheader">Function Documentation</h2>
<a id="gad62183931e951ae45afbca95d8683153"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gad62183931e951ae45afbca95d8683153">&#9670;&nbsp;</a></span>fwClassExists()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool fwClassExists </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>className</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Check if specified class or struct exists</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">className</td><td>the name of the class to be checked </td></tr>
  </table>
  </dd>
</dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname">errClass(ErrCode=76)</td><td>on invalid or missing input parameter (ErrCode::ILLEGAL_ARG) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>TRUE if the class or struct specified in <code>className</code> is known to the CTRL interpretter </dd></dl>

</div>
</div>
<a id="gaeb37d71db0ded24e58e2c45a1818be56"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gaeb37d71db0ded24e58e2c45a1818be56">&#9670;&nbsp;</a></span>fwClassNames()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">dyn_string fwClassNames </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Returns the list of all class and struct names</p>
<p>The function returns the list of all CTRL++ class and struct names currently known to the CTRL interpretter.</p>
<dl class="section return"><dt>Returns</dt><dd>the list of the class/struct names </dd></dl>

</div>
</div>
<a id="gae63ccc45ff8b44cd2782c1dbd049c6fa"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gae63ccc45ff8b44cd2782c1dbd049c6fa">&#9670;&nbsp;</a></span>fwCreateInstance()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">shared_ptr&lt;className&gt; fwCreateInstance </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>className</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Creates a share'able object of specified class</p>
<p>The function creates a new object of the class which names is specified as a parameter. The object is created WITHOUT a call to the constructor. You may want to use <a class="el" href="group__CtrlOOUtils.html#ga739d2d178d1779dee2ac1534e5d906c9">fwInvokeMethod</a> to call the constructor explicitly, specifying the name of the class as method name, and passing any arguments you wish.</p>
<dl class="section note"><dt>Note</dt><dd>the fact that the object is created without a constructor likely means that it is likely treated in the same way as objects created through the asssignment operator, ie. destructor may not be called for them (not checked).</dd></dl>
<p>The object is sharea'able, ie. suitable to be used through a <code>shared_ptr</code>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">className</td><td>the name of the class of which the object will be created</td></tr>
  </table>
  </dd>
</dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname">errClass(ErrCode=76)</td><td>on invalid or missing input parameters (ErrCode::ILLEGAL_ARG)</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>a shared pointer to the new instance of the object </dd></dl>

</div>
</div>
<a id="gab8fb94d265ae60ff799d1400c30e515d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gab8fb94d265ae60ff799d1400c30e515d">&#9670;&nbsp;</a></span>fwClassMemberVars()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">dyn_string fwClassMemberVars </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>className</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Returns the list of member variables of a class</p>
<p>The function returns the list of names of all member variables for a specified class. Only the names of the members are returned, not their full declarations (types, visibility)</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">className</td><td>specifies the name of the class</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>a list of names of member variables</dd></dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname">errClass(ErrCode=76)</td><td>on invalid or missing input parameter (ErrCode::ILLEGAL_ARG) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="gaab6a30d4d6ee78b09b03d8e19bbac2e7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gaab6a30d4d6ee78b09b03d8e19bbac2e7">&#9670;&nbsp;</a></span>fwClassMemberFuncs()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">dyn_string fwClassMemberFuncs </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>className</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Returns the list of methods of a class</p>
<p>The function returns the list of names of all methods for a specified class. Only the names of the methods, not their full declarations (types, parameters, etc)</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">className</td><td>specifies the name of the class</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>a list of names of method names</dd></dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname">errClass(ErrCode=76)</td><td>on invalid or missing input parameter (ErrCode::ILLEGAL_ARG) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ga112498c037a24d2560b5f2323be8f74d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga112498c037a24d2560b5f2323be8f74d">&#9670;&nbsp;</a></span>fwGetBaseClass()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string fwGetBaseClass </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>className</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Returns the base name of a base class</p>
<p>The function returns the name of the direct base class of the specified class.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">className</td><td>specifies the name of the class</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the name of the base class</dd></dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname">errClass(ErrCode=76)</td><td>on invalid or missing input parameter (ErrCode::ILLEGAL_ARG) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ga8b712c1097489b183594acb71eabcbe6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga8b712c1097489b183594acb71eabcbe6">&#9670;&nbsp;</a></span>fwIsInstanceOf()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool fwIsInstanceOf </td>
          <td>(</td>
          <td class="paramtype">const anytype &amp;obj|const shared_ptr&lt;&gt;&#160;</td>
          <td class="paramname"><em>obj</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>className</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Checks if object is derived from specified base class</p>
<p>Checks whether the object passed in the parameter is an instance of a specific class or of a class that is derived from specified class. For example, the function could be used to check if a particular object follows an interface that is specified by defining a base class, or if it could be safely casted.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">obj</td><td>is the object or a shared pointer to an object which is going to be inspected </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">className</td><td>the name of the class</td></tr>
  </table>
  </dd>
</dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname">errClass(ErrCode=76)</td><td>on invalid or missing input parameter (ErrCode::ILLEGAL_ARG)</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>TRUE if it is derived or it is an instance of the specific class </dd></dl>

</div>
</div>
<a id="gadeb664365b7154026af82f6dcba38ecb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gadeb664365b7154026af82f6dcba38ecb">&#9670;&nbsp;</a></span>fwGetClass()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string fwGetClass </td>
          <td>(</td>
          <td class="paramtype">const anytype &amp;obj|const shared_ptr&lt;&gt; obj|vector&lt;&gt;&#160;</td>
          <td class="paramname"><em>obj</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Return the class name of the object</p>
<p>The function returns the name of the class or struct for the object, without additional decorators ("class").</p>
<p>Note that the function allows to find out the class of a shared_ptr passed to it, or a vector of objects (or shared pointers to them)</p><ul>
<li>in these cases it returns the name of the class (or structure) of elements of the vector or variable referred by shared_ptr</li>
</ul>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">obj</td><td>is the object or a shared pointer to an object which is going to be inspected, or a typed-vector of objects</td></tr>
  </table>
  </dd>
</dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname">errClass(ErrCode=76)</td><td>on invalid or missing input parameter (ErrCode::ILLEGAL_ARG)</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the name of the class </dd></dl>

</div>
</div>
<a id="gac80aceb06a55dbb12f70dc42a675d80b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gac80aceb06a55dbb12f70dc42a675d80b">&#9670;&nbsp;</a></span>fwGetFuncPtr()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">function_ptr fwGetFuncPtr </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>funcName</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Gets a function_ptr for a function</p>
<p>The function returns a function pointer for requested function. This compensates for lacking WinCC OA feature, whereby one could only pass static method of class to certain objects, and not functions for which one specifies the name. It also allows for meta-programming (resolving the function name at runtime) without the need for evalScript()</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">funcName</td><td>the name of the function</td></tr>
  </table>
  </dd>
</dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname">errClass(ErrCode=76)</td><td>on invalid or missing input parameter (ErrCode::ILLEGAL_ARG)</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the function pointer </dd></dl>

</div>
</div>
<a id="ga739d2d178d1779dee2ac1534e5d906c9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga739d2d178d1779dee2ac1534e5d906c9">&#9670;&nbsp;</a></span>fwInvokeMethod()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">anytype fwInvokeMethod </td>
          <td>(</td>
          <td class="paramtype">anytype &amp;obj|shared_ptr&lt;&gt;&#160;</td>
          <td class="paramname"><em>obj</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>method</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>...</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Invokes a named method on an object</p>
<p>The function allows to invoke a method on an object, with the method name passed as a parameter; method parameters (including references for in-out values) may be passed, and the value returned by the invoked method is returned to the caller. The function is notably relevant for metaprogramming use cases.</p>
<dl class="section note"><dt>Note</dt><dd>At the moment the public/protected/private classifiers of the method are ignored.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">obj</td><td>object or shared pointer to the object on which the method is invoked</td></tr>
    <tr><td class="paramname">method</td><td>the name of the method to be invoked</td></tr>
    <tr><td class="paramname">...</td><td>all the rest of parameters will be passed to the invoked method</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the value returned by the invoked method </dd></dl>

</div>
</div>
<a id="ga1cfe49316c787c256b0fd32b310f7225"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga1cfe49316c787c256b0fd32b310f7225">&#9670;&nbsp;</a></span>fwRethrow()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwRethrow </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Rethrows exception with proper stack trace</p>
<p>The function should be used in the exception <code>catch</code> block to properly rethrow the current exception, without altering the call stack information. It works around the missing functionality reported in the ETM-1710 issue.</p>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname">errClass</td><td>with exception that is currently present in the <code>catch</code> block </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="gafaecd441269ebe1c4883b2b53cce980e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gafaecd441269ebe1c4883b2b53cce980e">&#9670;&nbsp;</a></span>fwThrowWithStackTrace()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwThrowWithStackTrace </td>
          <td>(</td>
          <td class="paramtype">errClass|dyn_errClass&#160;</td>
          <td class="paramname"><em>exception</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string stackTrace|int&#160;</td>
          <td class="paramname"><em>cutFrames</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Throws exception with specified stackTrace</p>
<p>The function allows to throw an exception passing a custom stack trace as a parameter. It is of particular interest to the fwCore functionality of exceptions, whereby one wants to cut-off the unnecessary stack frames of the exception-throwing method itself. It also compensates for the missing functionality of defining or setting the stackTrace information of a errClass variable.</p>
<p>Either the <code>stackTrace</code> or <code>framesToCut</code> parameter may be specified, and the actual behaviour is determined by the type of the parameter passed to the function (see description of the parameters).</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">exception</td><td>the errClass variable already containing details of the exception to be thrown </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">stackTrace</td><td>a dyn_string which should contain the stack frames; it will be put into the exception before it is thrown </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">cutFrames=0</td><td>if the parameter passed to the function is on the int-type the current stack is taken, then the number of stack frames specified in this parameter are truncated from its top, and then the resulting exception is thrown. If the parameter is skipped, or the <code>cutFrames</code> parameters is zero then the current stack trace will be used.</td></tr>
  </table>
  </dd>
</dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname">exception</td><td>that was passed as the argument, with its stack trace set to the <code>stackTrace</code> or truncated by <code>cutFrames</code> </td></tr>
    <tr><td class="paramname">errClass(ErrCode=75,76)</td><td>on invalid or missing input parameters (ErrCode::ARG_MISSING,ErrCode::ILLEGAL_ARG) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ga2398c9f637e4ea11cf138e728ececdbf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga2398c9f637e4ea11cf138e728ececdbf">&#9670;&nbsp;</a></span>fwGetMember()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">anytype fwGetMember </td>
          <td>(</td>
          <td class="paramtype">const anytype &amp;obj|shared_ptr&lt;&gt;&#160;</td>
          <td class="paramname"><em>obj</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>memberName</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Returns the value of a member of an object</p>
<p>The function could be used to get the value of any data member of an object, specifying it by name. Note that the private/protected specifiers are overriden!</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">obj</td><td>instance of thh object or shared pointer to it </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">memberName</td><td>the name of the member the value of which is to be retrieved</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the value of the member</dd></dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname">exceptions</td><td>on wrong parameters or non-existing memberName </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1 </li>
  </ul>
</div>
</body>
</html>
